searchData={"items":[{"type":"module","title":"Exmbus","doc":"Documentation for `Exmbus`.","ref":"Exmbus.html"},{"type":"function","title":"Exmbus.crc!/1","doc":"Calculate the CRC relevant for mbus (crc_16_en_13757)","ref":"Exmbus.html#crc!/1"},{"type":"function","title":"Exmbus.parse/2","doc":"","ref":"Exmbus.html#parse/2"},{"type":"function","title":"Exmbus.parse!/2","doc":"","ref":"Exmbus.html#parse!/2"},{"type":"module","title":"Exmbus.Crypto","doc":"Wraps the crypto functions used in the Exmbus library.","ref":"Exmbus.Crypto.html"},{"type":"type","title":"Exmbus.Crypto.cipher_iv/0","doc":"","ref":"Exmbus.Crypto.html#t:cipher_iv/0"},{"type":"type","title":"Exmbus.Crypto.cipher_no_iv/0","doc":"","ref":"Exmbus.Crypto.html#t:cipher_no_iv/0"},{"type":"type","title":"Exmbus.Crypto.crypto_error/0","doc":"","ref":"Exmbus.Crypto.html#t:crypto_error/0"},{"type":"type","title":"Exmbus.Crypto.crypto_error_c_fileinfo/0","doc":"","ref":"Exmbus.Crypto.html#t:crypto_error_c_fileinfo/0"},{"type":"type","title":"Exmbus.Crypto.crypto_error_description/0","doc":"","ref":"Exmbus.Crypto.html#t:crypto_error_description/0"},{"type":"type","title":"Exmbus.Crypto.crypto_error_tag/0","doc":"","ref":"Exmbus.Crypto.html#t:crypto_error_tag/0"},{"type":"function","title":"Exmbus.Crypto.crypto_one_time/4","doc":"Wraps the crypto_one_time function from the crypto module, just like crypto_one_time/5, but without the IV.","ref":"Exmbus.Crypto.html#crypto_one_time/4"},{"type":"function","title":"Exmbus.Crypto.crypto_one_time/5","doc":"Wraps the crypto_one_time function from the crypto module, catching errors and returning them as {:error, {:crypto_error, e}} tuples.\nWe do this to prevent a bad key from crashing the parse.","ref":"Exmbus.Crypto.html#crypto_one_time/5"},{"type":"type","title":"Exmbus.Crypto.crypto_opts/0","doc":"","ref":"Exmbus.Crypto.html#t:crypto_opts/0"},{"type":"module","title":"Exmbus.Key","doc":"This module provides a way to define and retrieve keys for the Exmbus parser.","ref":"Exmbus.Key.html"},{"type":"function","title":"Exmbus.Key.by_fn!/1","doc":"","ref":"Exmbus.Key.html#by_fn!/1"},{"type":"function","title":"Exmbus.Key.from_options/1","doc":"","ref":"Exmbus.Key.html#from_options/1"},{"type":"function","title":"Exmbus.Key.from_options!/1","doc":"","ref":"Exmbus.Key.html#from_options!/1"},{"type":"function","title":"Exmbus.Key.get/1","doc":"Short-hand for getting the key struct out of the option key :key\nand calling key on that.\n\nSee get/3","ref":"Exmbus.Key.html#get/1"},{"type":"function","title":"Exmbus.Key.get/2","doc":"Given a Key struct, will invoke key function with options and context,\nand return a list of keys from the key function, or an error as appropriate.\n\n  iex> key = Key.by_fn!(fn(_ctx) -> {:ok, [<<1>>, <<2>>]} end)\n  iex> {:ok, [<<1>>, <<2>>]} = Key.get(key, Exmbus.Parser.Context.new())","ref":"Exmbus.Key.html#get/2"},{"type":"type","title":"Exmbus.Key.t/0","doc":"","ref":"Exmbus.Key.html#t:t/0"},{"type":"module","title":"Exmbus.Parser","doc":"Responsible for parsing the binary data into a structured format.","ref":"Exmbus.Parser.html"},{"type":"function","title":"Exmbus.Parser.parse/1","doc":"Parse the parse context until it's handler stack is empty, or it has errors.\n\nReturns {:ok, ctx} if parsing was successful, or {:error, ctx} if parsing failed.","ref":"Exmbus.Parser.html#parse/1"},{"type":"module","title":"Exmbus.Parser.Apl","doc":"Parser for the APL layer. Dispatches to the correct parser based on the frame type of the TPL layer.\n\nIf you don't have a TPL layer, you most likely want call the `FullFrame.parse/1` instead.","ref":"Exmbus.Parser.Apl.html"},{"type":"function","title":"Exmbus.Parser.Apl.parse/1","doc":"Decode the Application Layer and return one of the Apl frame structs.\n\nThe Application Layer consists of N number of records where N >= 0,\nand some optional manufacturer specific data.\n\nThe function assumes that the entire input is the APL layer data.","ref":"Exmbus.Parser.Apl.html#parse/1"},{"type":"module","title":"Exmbus.Parser.Apl.CompactFrame","doc":"Parser for a CompactFrame.\n\nA CompactFrame contains only the data bytes of a full frame.\nIt must be used in conbination with a FormatFrame to create a full frame.","ref":"Exmbus.Parser.Apl.CompactFrame.html"},{"type":"function","title":"Exmbus.Parser.Apl.CompactFrame.expand/1","doc":"Given some options and a parsed context with a CompactFrame on top, will expand the\ntop CompactFrame struct into a FullFrame struct and return {:ok, [%FullFrame{} | rest]}\n\nThe option :format_frame_fn must be set to a 2-arity function that receives a format signature and\nthe remaining options, and return {:ok, %FormatFrame{}}\n\nThe Full-Frame-CRC from the compact frame will be verified against the expanded FullFrame,\nand an error returned if they do not match. This behaviour can be disabled with the option :verify_full_frame_crc","ref":"Exmbus.Parser.Apl.CompactFrame.html#expand/1"},{"type":"function","title":"Exmbus.Parser.Apl.CompactFrame.maybe_expand/1","doc":"This function will expand the compact frame into a full frame.\nIf the APL in the context is not a CompactFrame, it will return {:next, ctx}","ref":"Exmbus.Parser.Apl.CompactFrame.html#maybe_expand/1"},{"type":"function","title":"Exmbus.Parser.Apl.CompactFrame.parse/1","doc":"","ref":"Exmbus.Parser.Apl.CompactFrame.html#parse/1"},{"type":"module","title":"Exmbus.Parser.Apl.DataRecord","doc":"Parser for a DataRecord.","ref":"Exmbus.Parser.Apl.DataRecord.html"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.compact_profile?/1","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.html#compact_profile?/1"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.compact_profile_records/2","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.html#compact_profile_records/2"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.expand_compact_profile/2","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.html#expand_compact_profile/2"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.parse/2","doc":"Decodes a single DataRecord from a binary.","ref":"Exmbus.Parser.Apl.DataRecord.html#parse/2"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.parse_data/2","doc":"decodes a value associated with a given header.","ref":"Exmbus.Parser.Apl.DataRecord.html#parse_data/2"},{"type":"type","title":"Exmbus.Parser.Apl.DataRecord.t/0","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.html#t:t/0"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.to_map!/1","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.html#to_map!/1"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.unit/1","doc":"Returns the unit for a DataRecord as a string.\nThis string will have any relevant extensions added it to, so it might differ from the\nraw unit in the header's Value Information Block.","ref":"Exmbus.Parser.Apl.DataRecord.html#unit/1"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.unit!/1","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.html#unit!/1"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.unparse/1","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.html#unparse/1"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.unparse_data/2","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.html#unparse_data/2"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.value/1","doc":"Retrieve the simplified value of the DataRecord.\nThe value is calculated from the decoded data, modified with added extensions\nfound in the header.","ref":"Exmbus.Parser.Apl.DataRecord.html#value/1"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.value!/1","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.html#value!/1"},{"type":"module","title":"Exmbus.Parser.Apl.DataRecord.CompactProfile","doc":"This module provides functions for working with compact profiles.\n\nCompact Profile is a way to encode multiple values into a single data record\nfor efficient transfer, typically because there is an even spacing between\nthe values (e.g. monthly data for last 12 months)\n\nThere are 3 types of compact profiles described in Annex F of EN 13757-3:2018.\n\n- \"Compact Profile with register numbers\"\n- \"Compact Profile\"\n- \"Inverse Compact Profile\"\n\nThe compact profile data layout is described as follows:\n\n> The first byte (spacing control byte, Tables E.6 and F.7) of this variable length record structure contains\n> the data size of each individual element in the lower four bits (as in the lower nibble of the DIF definitions,\n> but excluding variable length elements). The next higher two bits signal the time spacing units (00b = sec,\n> 01b = min, 10b = hours and 11b = days). The highest two bits signal the increment mode of the profile\n> (00b = absolute value (signed), 01, = positive (unsigned) increments (all differences ≥ 0),\n> 10b = negative (unsigned) increments (all differences ≤ 0, 11b = signed difference, with: difference = younger value minus older value).\n> All values of the profile are initially preset with the coding for \"illegal\",\n> e.g. -128 for signed byte, 255 for unsigned byte, -32768 for signed word, etc. (refer toAnnex A, type B and C).\n> Invalid values shall also be used in case of an overflow of an incremental value.\n\nCompact Profiles are automatically expanded by default.\nThis can be disabled with the option `expand_compact_profiles: false` in the options map.","ref":"Exmbus.Parser.Apl.DataRecord.CompactProfile.html"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.CompactProfile.compact_profile?/1","doc":"Return true if the record is a compact profile record. false otherwise.","ref":"Exmbus.Parser.Apl.DataRecord.CompactProfile.html#compact_profile?/1"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.CompactProfile.compact_profile_records/2","doc":"Given a compact profile record, and a list of records to search for base records,\nexpand the compact profile record into a list of records.\nThe returned list only contains the expanded reocrds, not the compact profile record itself,\nand not anything from the records in the second argument.","ref":"Exmbus.Parser.Apl.DataRecord.CompactProfile.html#compact_profile_records/2"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.CompactProfile.expand_compact_profile/2","doc":"Expand a compact profile record into the given context.\nThe compact profile record will be removed from the context's records, and replaced with the\nderived records from the compact profile.","ref":"Exmbus.Parser.Apl.DataRecord.CompactProfile.html#expand_compact_profile/2"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.CompactProfile.parse_data/2","doc":"Given a CompactProfileHeader and the profile data (as a binary), parse the values\naccording to the header and return a list of parsed values.","ref":"Exmbus.Parser.Apl.DataRecord.CompactProfile.html#parse_data/2"},{"type":"module","title":"Exmbus.Parser.Apl.DataRecord.CompactProfile.CompactProfileHeader","doc":"This module represents the Compact Profile header.\n\nThe Compact Profile allows you to cram a lot of values with same data type and time spacing\nto be crammed into a very small payload.\n\nIt is generally used to send values at the end of each window e.g. month 12 months back,\nin each telegram.","ref":"Exmbus.Parser.Apl.DataRecord.CompactProfile.CompactProfileHeader.html"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.CompactProfile.CompactProfileHeader.parse/1","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.CompactProfile.CompactProfileHeader.html#parse/1"},{"type":"module","title":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock","doc":"Utilities for DIB parsing","ref":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.html"},{"type":"type","title":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.data_type/0","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.html#t:data_type/0"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.decode_data_field/1","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.html#decode_data_field/1"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.decode_function_field/1","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.html#decode_function_field/1"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.default_coding/1","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.html#default_coding/1"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.encode_data_field/2","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.html#encode_data_field/2"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.encode_function_field/1","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.html#encode_function_field/1"},{"type":"type","title":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.function_field/0","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.html#t:function_field/0"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.parse/2","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.html#parse/2"},{"type":"type","title":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.t/0","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.html#t:t/0"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.unparse/1","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.DataInformationBlock.html#unparse/1"},{"type":"module","title":"Exmbus.Parser.Apl.DataRecord.Header","doc":"This module represents the header of a DataRecord.","ref":"Exmbus.Parser.Apl.DataRecord.Header.html"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.Header.parse/2","doc":"Parses the next DataRecord Header from a binary.","ref":"Exmbus.Parser.Apl.DataRecord.Header.html#parse/2"},{"type":"type","title":"Exmbus.Parser.Apl.DataRecord.Header.t/0","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.Header.html#t:t/0"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.Header.unparse/1","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.Header.html#unparse/1"},{"type":"module","title":"Exmbus.Parser.Apl.DataRecord.Header.InvalidHeader","doc":"This module represents an invalid header.","ref":"Exmbus.Parser.Apl.DataRecord.Header.InvalidHeader.html"},{"type":"module","title":"Exmbus.Parser.Apl.DataRecord.InvalidDataRecord","doc":"This module represents an invalid DataRecord.","ref":"Exmbus.Parser.Apl.DataRecord.InvalidDataRecord.html"},{"type":"module","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock","doc":"The Value Information Block utilities","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.html"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.parse/2","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.html#parse/2"},{"type":"type","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.t/0","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.html#t:t/0"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.unparse/1","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.html#unparse/1"},{"type":"module","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.ErrorCode","doc":"Decode/Encode error codes for the value information block (VIB) of a data record.","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.ErrorCode.html"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.ErrorCode.decode/1","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.ErrorCode.html#decode/1"},{"type":"module","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.VifTableFB","doc":"This module implements the VIF extension table FB (0xFB)","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.VifTableFB.html"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.VifTableFB.parse/2","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.VifTableFB.html#parse/2"},{"type":"module","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.VifTableFD","doc":"This module implements the VIF extension table FD (0xFD)","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.VifTableFD.html"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.VifTableFD.parse/2","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.VifTableFD.html#parse/2"},{"type":"module","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.VifTableMain","doc":"Parse module for the primary VIF table.\n\nEN 13757-3:2018(EN) - 6.4.2 Primary VIFs (main table)","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.VifTableMain.html"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.VifTableMain.parse/2","doc":"","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.VifTableMain.html#parse/2"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.VifTableMain.unparse/1","doc":"Unparse a VIB contact from the main table.\n\nTODO: implement unparsing VIBs with extensions","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.VifTableMain.html#unparse/1"},{"type":"module","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.Vife","doc":"Takes care of VIF extension parsing.\n\nIt might be possible to refactor this away at some point, but right\nnow it seems like a lot of the VIFE functionality is the same across\nVIF tables, so we gather it all here.","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.Vife.html"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.Vife.consume/2","doc":"Consume all VIFE bytes and return them.\nUseful for ignoring VIFE.","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.Vife.html#consume/2"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.Vife.error/4","doc":"Ignore VIFE and return {:error, reason, rest}","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.Vife.html#error/4"},{"type":"function","title":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.Vife.parse/3","doc":"Parse VIFEs into a %VIB{} struct.\nThe first argument is the extension bit from the previous byte.\nWhen a function call sees a zero from the previous extension bit,\nwe know that `rest` isn't part of the VIFE and we can return the accumulated VIB and rest of data.","ref":"Exmbus.Parser.Apl.DataRecord.ValueInformationBlock.Vife.html#parse/3"},{"type":"module","title":"Exmbus.Parser.Apl.FormatFrame","doc":"Parser for a format frame.\n\nA FormatFrame contains headers. It can be used on combination with\na CompactFrame to create a full frame.","ref":"Exmbus.Parser.Apl.FormatFrame.html"},{"type":"function","title":"Exmbus.Parser.Apl.FormatFrame.format_signature/1","doc":"","ref":"Exmbus.Parser.Apl.FormatFrame.html#format_signature/1"},{"type":"function","title":"Exmbus.Parser.Apl.FormatFrame.from_full_frame!/1","doc":"","ref":"Exmbus.Parser.Apl.FormatFrame.html#from_full_frame!/1"},{"type":"function","title":"Exmbus.Parser.Apl.FormatFrame.parse/1","doc":"","ref":"Exmbus.Parser.Apl.FormatFrame.html#parse/1"},{"type":"module","title":"Exmbus.Parser.Apl.FullFrame","doc":"Parser for a full frame.\n\nA FullFrame contains a list of data records.","ref":"Exmbus.Parser.Apl.FullFrame.html"},{"type":"function","title":"Exmbus.Parser.Apl.FullFrame.expand_compact_profiles/1","doc":"","ref":"Exmbus.Parser.Apl.FullFrame.html#expand_compact_profiles/1"},{"type":"function","title":"Exmbus.Parser.Apl.FullFrame.format_signature/1","doc":"","ref":"Exmbus.Parser.Apl.FullFrame.html#format_signature/1"},{"type":"function","title":"Exmbus.Parser.Apl.FullFrame.full_frame_crc/1","doc":"","ref":"Exmbus.Parser.Apl.FullFrame.html#full_frame_crc/1"},{"type":"function","title":"Exmbus.Parser.Apl.FullFrame.maybe_expand_compact_profiles/1","doc":"This function will expand compact profiles in the APL unless the option `expand_compact_profiles` is false.","ref":"Exmbus.Parser.Apl.FullFrame.html#maybe_expand_compact_profiles/1"},{"type":"function","title":"Exmbus.Parser.Apl.FullFrame.parse/1","doc":"","ref":"Exmbus.Parser.Apl.FullFrame.html#parse/1"},{"type":"module","title":"Exmbus.Parser.Binary","doc":"Utility to find and collect bytes in a binary.","ref":"Exmbus.Parser.Binary.html"},{"type":"function","title":"Exmbus.Parser.Binary.collect_by_extension_bit/1","doc":"Collect a sequence of bytes where the first bit in each byte\nrepresents if the next byte is part of the sequence.\nMeaning the returned binary will have the first bit of each byte set, except the last byte.","ref":"Exmbus.Parser.Binary.html#collect_by_extension_bit/1"},{"type":"function","title":"Examples: - Exmbus.Parser.Binary.collect_by_extension_bit/1","doc":"iex> {:ok, <<0xFF, 0x00>>, <<0x00>>} = collect_by_extension_bit(<<0xFF, 0x00, 0x00>>)\n\n    iex> {:ok, <<0x00>>, <<0x00>>} = collect_by_extension_bit(<<0x00, 0x00>>)\n\n    iex> {:ok, <<0x80, 0x80, 0x00>>, <<0x00>>} = collect_by_extension_bit(<<1::1, 0::7, 1::1, 0::7, 0x00, 0x00>>)","ref":"Exmbus.Parser.Binary.html#collect_by_extension_bit/1-examples"},{"type":"module","title":"Exmbus.Parser.CI","doc":"MBus CI codes found in table 2 of EN-13757-7:2018\n\nNote: If APL then TPL is also implied because EN 13757-7:2018 section 5.2:\n    The Transport Layer and the Application Layer uses a shared CI-field.\n    For that reason, a Transport Layer shall be present whenever the Application Layer is used in a message.","ref":"Exmbus.Parser.CI.html"},{"type":"function","title":"Exmbus.Parser.CI.lookup/1","doc":"Lookup a CI number against the CI table.\nreturns corresponding layer and layer extension, or an error.","ref":"Exmbus.Parser.CI.html#lookup/1"},{"type":"module","title":"Exmbus.Parser.Context","doc":"Parsing context, accumulating errors and layers.","ref":"Exmbus.Parser.Context.html"},{"type":"function","title":"Exmbus.Parser.Context.add_error/2","doc":"Add an error to the context and return the updated context.","ref":"Exmbus.Parser.Context.html#add_error/2"},{"type":"function","title":"Exmbus.Parser.Context.add_warning/2","doc":"Add a warning to the context and return the updated context.","ref":"Exmbus.Parser.Context.html#add_warning/2"},{"type":"function","title":"Exmbus.Parser.Context.append_handlers/2","doc":"Append additional handlers to the context.","ref":"Exmbus.Parser.Context.html#append_handlers/2"},{"type":"function","title":"Exmbus.Parser.Context.default_handlers/0","doc":"Return the list of default handlers.","ref":"Exmbus.Parser.Context.html#default_handlers/0"},{"type":"function","title":"Exmbus.Parser.Context.handle/1","doc":"Apply the context to the next handler in the list.","ref":"Exmbus.Parser.Context.html#handle/1"},{"type":"function","title":"Exmbus.Parser.Context.merge_opts/2","doc":"Merge options with the existing options in the context.","ref":"Exmbus.Parser.Context.html#merge_opts/2"},{"type":"function","title":"Exmbus.Parser.Context.new/1","doc":"Create a new context  with default handlers, and merge the given attributes into the context.","ref":"Exmbus.Parser.Context.html#new/1"},{"type":"function","title":"Exmbus.Parser.Context.prepend_handlers/2","doc":"Prepend additional handlers to the context.\n\nPrepending handlers will make the given handlers run before the existing handlers.","ref":"Exmbus.Parser.Context.html#prepend_handlers/2"},{"type":"type","title":"Exmbus.Parser.Context.t/0","doc":"","ref":"Exmbus.Parser.Context.html#t:t/0"},{"type":"module","title":"Exmbus.Parser.DataType","doc":"Contains functions for working with data encoded according to EN 13757-3:2018 section 6.3.3 (Table 4)\nand specified in Annex A of same document.\n\nIt also implements working with variable-length data (LVAR) according to same document same section (Table 5)","ref":"Exmbus.Parser.DataType.html"},{"type":"function","title":"Exmbus.Parser.DataType.decode_lvar/2","doc":"Decode an LVAR value from binary.\nThis is a variable-length-style encoding, but with a twist (as with most things in mbus),\nso it requires a bit more work than < >.\n\nIt takes an optional argument `mode` which is an atom indicating what decode method to apply\nin case of LVAR 0x00–0xBF, since that can be both ISO 8859-1 encoded text, or it can be\nraw bytes in case of VIFs that need a container type.\n\nCurrently the following are container types:\n  # If VIF is from the FD extension table and is:\n  # - 0bE0111011 then it's wmbus\n  # - 0bE1110110 then it's manifacturer specific bytes\n\nThe default is currently `:container` mode which just returns the bytes as a binary.\nThis is what the old parser does as well, but we could a latin1 decoder in here if someone\nactually sends non-ascii text to us, which is the only case where it would be needed\n(because in elixir Strings are just binary data in UTF-8, and both Latin-1 and UTF-8 are extensions\nto ASCII, so by coincedence, if you send ASCII-only characters it will be the same in both UTF-8 and Latin-1,\nand elixir binary data and elixir strings are the same, so we don't need to do any conversion.)\n\n  # raw bytes container\n  iex> decode_lvar(<<5, \"hello\", 0xFF>>, :container)\n  {:ok, <<\"hello\">>, <<0xFF>>}\n\n  # empty container\n  iex> decode_lvar(<<0, 0xFF>>, :container)\n  {:ok, <<>>, <<0xFF>>}\n\n  # empty positive BCD number\n  iex> decode_lvar(<<0xC0, 0xFF>>)\n  {:ok, 0, <<0xFF>>}\n\n  # positive BCD number\n  iex> decode_lvar(<<0xC1, 0x10, 0xFF>>)\n  {:ok, 10, <<0xFF>>}\n\n  # empty negative BCD number\n  iex> decode_lvar(<<0xD0, 0xFF>>)\n  {:ok, 0, <<0xFF>>}\n\n  # negative BCD number\n  iex> decode_lvar(<<0xD1, 0x10, 0xFF>>)\n  {:ok, -10, <<0xFF>>}\n\n  # negative multi-byte BCD number\n  iex> decode_lvar(<<0xD2, 0x34, 0x12, 0xFF>>)\n  {:ok, -1234, <<0xFF>>}\n\n  # LVAR binary number\n  iex> decode_lvar(<<0xE1, 123::signed-little-size(8), 0xFF>>)\n  {:ok, 123, <<0xFF>>}\n\n  # LVAR binary number\n  iex> decode_lvar(<<0xE4, -123456789::signed-little-size(32), 0xFF>>)\n  {:ok, -123456789, <<0xFF>>}\n\n  iex> decode_lvar(<<5, \"hel\">>, :container)\n  {:error, {:not_enough_bytes_for_lvar, 5, \"hel\"}, <<>>}","ref":"Exmbus.Parser.DataType.html#decode_lvar/2"},{"type":"function","title":"Exmbus.Parser.DataType.decode_type_a/2","doc":"Type A\nBCD integer.\nif MSB 0xF then the remanining digits are interpreted as a negative number\n\n  iex> decode_type_a(<<0x34, 0x12, 0xFF>>, 16)\n  {:ok, 1234, <<0xFF>>}\n\n  iex> decode_type_a(<<0x23, 0xF1, 0xFF>>, 16)\n  {:ok, -123, <<0xFF>>}\n\n  iex> decode_type_a(<<0x23, 0xC1, 0xFF>>, 16)\n  {:ok, {:invalid, {:type_a, 0xC123}}, <<0xFF>>}","ref":"Exmbus.Parser.DataType.html#decode_type_a/2"},{"type":"function","title":"Exmbus.Parser.DataType.decode_type_b/2","doc":"Type B\nSigned little-endian integer\n\n  iex> decode_type_b(<<-1234::signed-little-size(16), 0xFF>>, 16)\n  {:ok, -1234, <<0xFF>>}","ref":"Exmbus.Parser.DataType.html#decode_type_b/2"},{"type":"function","title":"Exmbus.Parser.DataType.decode_type_c/2","doc":"Type C\nUnsigned little-endian integer\n\n  iex> decode_type_c(<<1234::unsigned-little-size(16), 0xFF>>, 16)\n  {:ok, 1234, <<0xFF>>}","ref":"Exmbus.Parser.DataType.html#decode_type_c/2"},{"type":"function","title":"Exmbus.Parser.DataType.decode_type_d/2","doc":"Type D\nBool list from bits.\n\n  iex> decode_type_d(<<0b0000111111110000::unsigned-little-size(16), 0xFF>>, 16)\n  {:ok, [false, false, false, false, true, true, true, true, true, true, true, true, false, false, false, false], <<0xFF>>}","ref":"Exmbus.Parser.DataType.html#decode_type_d/2"},{"type":"function","title":"Exmbus.Parser.DataType.decode_type_f/1","doc":"Type F\nConvert 32 bits to a NaiveDateTime with seconds truncated to 0.\n(Type F is a date+time without seconds specified, but we just truncate. Good Enough :tm:)\n\n  iex> decode_type_f(<<0b00::2, 10::6, 0::1, 0::2, 20::5, 0b101::3, 1::5, 0b0010::4, 2::4, 0xFF>>)\n  {:ok, ~N[2021-02-01 20:10:00], <<0xFF>>}","ref":"Exmbus.Parser.DataType.html#decode_type_f/1"},{"type":"function","title":"Exmbus.Parser.DataType.decode_type_g/1","doc":"Type G\nConvert 16 bits to a Date\n\n  iex> decode_type_g(<<0b101::3, 1::5, 0b0010::4, 2::4, 0xFF>>)\n  {:ok, ~D[2021-02-01], <<0xFF>>}\n\n  iex> decode_type_g(<<0xFF, 0xFF, 0xFF>>)\n  {:ok, :invalid, <<0xFF>>}","ref":"Exmbus.Parser.DataType.html#decode_type_g/1"},{"type":"function","title":"Exmbus.Parser.DataType.decode_type_h/1","doc":"","ref":"Exmbus.Parser.DataType.html#decode_type_h/1"},{"type":"function","title":"Exmbus.Parser.DataType.decode_type_i/1","doc":"Type I\nConvert 48 bits to a NaiveDateTime\n(This isn't 1:1 with spec but without creating a new type for DateTime this is the closest we get)","ref":"Exmbus.Parser.DataType.html#decode_type_i/1"},{"type":"function","title":"Exmbus.Parser.DataType.decode_type_j/1","doc":"Type J\nConvert 24 bits to a Time\n\n  iex> decode_type_j(<<59, 48, 11, 0xFF>>)\n  {:ok, ~T[11:48:59], <<0xFF>>}","ref":"Exmbus.Parser.DataType.html#decode_type_j/1"},{"type":"function","title":"Exmbus.Parser.DataType.decode_type_k/1","doc":"","ref":"Exmbus.Parser.DataType.html#decode_type_k/1"},{"type":"function","title":"Exmbus.Parser.DataType.decode_type_l/1","doc":"","ref":"Exmbus.Parser.DataType.html#decode_type_l/1"},{"type":"function","title":"Exmbus.Parser.DataType.decode_type_m/1","doc":"","ref":"Exmbus.Parser.DataType.html#decode_type_m/1"},{"type":"function","title":"Exmbus.Parser.DataType.encode_lvar/1","doc":"","ref":"Exmbus.Parser.DataType.html#encode_lvar/1"},{"type":"function","title":"Exmbus.Parser.DataType.encode_type_a/2","doc":"","ref":"Exmbus.Parser.DataType.html#encode_type_a/2"},{"type":"function","title":"Exmbus.Parser.DataType.encode_type_b/2","doc":"","ref":"Exmbus.Parser.DataType.html#encode_type_b/2"},{"type":"function","title":"Exmbus.Parser.DataType.encode_type_c/2","doc":"","ref":"Exmbus.Parser.DataType.html#encode_type_c/2"},{"type":"function","title":"Exmbus.Parser.DataType.encode_type_d/2","doc":"","ref":"Exmbus.Parser.DataType.html#encode_type_d/2"},{"type":"function","title":"Exmbus.Parser.DataType.encode_type_f/1","doc":"","ref":"Exmbus.Parser.DataType.html#encode_type_f/1"},{"type":"function","title":"Exmbus.Parser.DataType.encode_type_g/1","doc":"Encode a Date to type G (16 bit)\n\n  # <<161, 34>> = <<5::3, 1::5, 2::4, 2::4>>\n  iex> {:ok, <<161, 34>>} = encode_type_g(~D[2021-02-01])","ref":"Exmbus.Parser.DataType.html#encode_type_g/1"},{"type":"function","title":"Exmbus.Parser.DataType.encode_type_h/1","doc":"","ref":"Exmbus.Parser.DataType.html#encode_type_h/1"},{"type":"function","title":"Exmbus.Parser.DataType.encode_type_i/1","doc":"","ref":"Exmbus.Parser.DataType.html#encode_type_i/1"},{"type":"function","title":"Exmbus.Parser.DataType.encode_type_j/1","doc":"","ref":"Exmbus.Parser.DataType.html#encode_type_j/1"},{"type":"function","title":"Exmbus.Parser.DataType.encode_type_k/1","doc":"","ref":"Exmbus.Parser.DataType.html#encode_type_k/1"},{"type":"function","title":"Exmbus.Parser.DataType.encode_type_l/1","doc":"","ref":"Exmbus.Parser.DataType.html#encode_type_l/1"},{"type":"function","title":"Exmbus.Parser.DataType.encode_type_m/1","doc":"","ref":"Exmbus.Parser.DataType.html#encode_type_m/1"},{"type":"module","title":"Exmbus.Parser.Dll","doc":"Routes the parsing to the correct Dll parser,\neither Mbus or Wmbus.","ref":"Exmbus.Parser.Dll.html"},{"type":"function","title":"Exmbus.Parser.Dll.parse/1","doc":"","ref":"Exmbus.Parser.Dll.html#parse/1"},{"type":"module","title":"Exmbus.Parser.Dll.Mbus","doc":"Data Link Layer for Mbus","ref":"Exmbus.Parser.Dll.Mbus.html"},{"type":"function","title":"Exmbus.Parser.Dll.Mbus.direction/1","doc":"Return the communication direction of a Wmbus struct.\nThe possible values are: :to_meter, :from_meter, :both","ref":"Exmbus.Parser.Dll.Mbus.html#direction/1"},{"type":"function","title":"Exmbus.Parser.Dll.Mbus.parse/1","doc":"Parse an mbus message","ref":"Exmbus.Parser.Dll.Mbus.html#parse/1"},{"type":"module","title":"Exmbus.Parser.Dll.Wmbus","doc":"Data Link Layer for WMbus","ref":"Exmbus.Parser.Dll.Wmbus.html"},{"type":"function","title":"Exmbus.Parser.Dll.Wmbus.direction/1","doc":"Return the communication direction of a Wmbus struct.\nThe possible values are: :to_meter, :from_meter, :both","ref":"Exmbus.Parser.Dll.Wmbus.html#direction/1"},{"type":"function","title":"Exmbus.Parser.Dll.Wmbus.parse/1","doc":"Parse a wmbus message","ref":"Exmbus.Parser.Dll.Wmbus.html#parse/1"},{"type":"module","title":"Exmbus.Parser.Ell","doc":"Module responsible for handling the extended link layer\nSpec taken from EN 13757-4:2019.\n\nSee also the Exmbus.Parser.CI module.","ref":"Exmbus.Parser.Ell.html"},{"type":"function","title":"Exmbus.Parser.Ell.decrypt_bin/1","doc":"","ref":"Exmbus.Parser.Ell.html#decrypt_bin/1"},{"type":"function","title":"Exmbus.Parser.Ell.encrypt_bin/1","doc":"","ref":"Exmbus.Parser.Ell.html#encrypt_bin/1"},{"type":"function","title":"Exmbus.Parser.Ell.maybe_decrypt_bin/1","doc":"","ref":"Exmbus.Parser.Ell.html#maybe_decrypt_bin/1"},{"type":"function","title":"Exmbus.Parser.Ell.maybe_parse/1","doc":"Parses an extended link layer and adds it to the parse context.\n\nIn contrast to `parse/1`, this function will not fail if the data\ndoesn't contain an ELL. Instead, it will assign a `%None{}` struct\nto the ell context field.","ref":"Exmbus.Parser.Ell.html#maybe_parse/1"},{"type":"function","title":"Exmbus.Parser.Ell.parse/1","doc":"","ref":"Exmbus.Parser.Ell.html#parse/1"},{"type":"module","title":"Exmbus.Parser.Ell.CommunicationControl","doc":"This module represents the Communication Control (CC) field in the ELL layer.","ref":"Exmbus.Parser.Ell.CommunicationControl.html"},{"type":"function","title":"Exmbus.Parser.Ell.CommunicationControl.decode/1","doc":"Decode the CC (Communication Control) field from the ELL.\n\n  iex> decode_cc(<<0b00000000>>)\n  {:ok, %{bidirectional: false}}\n  iex> decode_cc(<<0b10000000>>)\n  {:ok, %{bidirectional: true}}","ref":"Exmbus.Parser.Ell.CommunicationControl.html#decode/1"},{"type":"function","title":"Exmbus.Parser.Ell.CommunicationControl.encode/1","doc":"","ref":"Exmbus.Parser.Ell.CommunicationControl.html#encode/1"},{"type":"module","title":"Exmbus.Parser.Ell.Encrypted","doc":"Represents an encrypted ELL layer.","ref":"Exmbus.Parser.Ell.Encrypted.html"},{"type":"function","title":"Exmbus.Parser.Ell.Encrypted.decrypt_bin/1","doc":"decrypts the context data according to the ELL layer.\n\nThis function will decrypt the encrypted bytes according to the ELL encryption mode.","ref":"Exmbus.Parser.Ell.Encrypted.html#decrypt_bin/1"},{"type":"function","title":"Exmbus.Parser.Ell.Encrypted.encrypt_bin/1","doc":"Encrypt the binary data according to the ELL layer encryption.\n\nMostly useful for re-keying an ELL.\n\nWill use the first key found in the key list if multiple keys are returned.","ref":"Exmbus.Parser.Ell.Encrypted.html#encrypt_bin/1"},{"type":"function","title":"Exmbus.Parser.Ell.Encrypted.maybe_decrypt_bin/1","doc":"decrypts the context data according to the ELL layer.\n\n  This function will decrypt the encrypted bytes according to the ELL encryption mode.\n  If the ell is not set, or is none, this function will return `{:next, ctx}`.","ref":"Exmbus.Parser.Ell.Encrypted.html#maybe_decrypt_bin/1"},{"type":"module","title":"Exmbus.Parser.Ell.None","doc":"This module represents the lack of an ELL layer.","ref":"Exmbus.Parser.Ell.None.html"},{"type":"module","title":"Exmbus.Parser.Ell.SessionNumber","doc":"This module represents the Session Number in the ELL layer.","ref":"Exmbus.Parser.Ell.SessionNumber.html"},{"type":"function","title":"Exmbus.Parser.Ell.SessionNumber.decode/1","doc":"Decode Session Number of ELL.\nSection 13.2.11 of EN 13757-4:2019","ref":"Exmbus.Parser.Ell.SessionNumber.html#decode/1"},{"type":"function","title":"Exmbus.Parser.Ell.SessionNumber.encode/1","doc":"","ref":"Exmbus.Parser.Ell.SessionNumber.html#encode/1"},{"type":"module","title":"Exmbus.Parser.Ell.Unencrypted","doc":"This module represents an unencrypted ELL layer.","ref":"Exmbus.Parser.Ell.Unencrypted.html"},{"type":"module","title":"Exmbus.Parser.IdentificationNo","doc":"Decode/Encode identification number (BCD) to/from binary representation.\n\nThe identification number is a 4-byte binary representation of a BCD number.\n\nIt can optionally contain `F` representing a wildcard digit.\n\n    iex> decode(<<0x78, 0x56, 0x34, 0x12>>)\n    {:ok, \"12345678\"}\n\n    iex> decode(<<0x78, 0x56, 0x34, 0xF2>>)\n    {:ok, \"F2345678\"}\n\n\n    iex> encode(\"12345678\")\n    {:ok, <<0x78, 0x56, 0x34, 0x12>>}\n\n    iex> encode(12345678)\n    {:ok, <<0x78, 0x56, 0x34, 0x12>>}","ref":"Exmbus.Parser.IdentificationNo.html"},{"type":"function","title":"Exmbus.Parser.IdentificationNo.decode/1","doc":"Decode from the binary representation of the identification number (BCD)","ref":"Exmbus.Parser.IdentificationNo.html#decode/1"},{"type":"function","title":"Exmbus.Parser.IdentificationNo.encode/1","doc":"Encode the identification number to binary representation (BCD)","ref":"Exmbus.Parser.IdentificationNo.html#encode/1"},{"type":"module","title":"Exmbus.Parser.Manufacturer","doc":"Implements encode/decode for the 2-byte manufacturer flag ID","ref":"Exmbus.Parser.Manufacturer.html"},{"type":"function","title":"Exmbus.Parser.Manufacturer.decode/1","doc":"Decode from binary to string representation of manufacturer\n\n  iex> decode(<<0x93, 0x44>>)\n  {:ok, \"QDS\"}","ref":"Exmbus.Parser.Manufacturer.html#decode/1"},{"type":"function","title":"Exmbus.Parser.Manufacturer.encode/1","doc":"Encode 3-letter manufacturer\n\n  iex> {:ok, <<0x93, 0x44>>} = encode(\"QDS\")","ref":"Exmbus.Parser.Manufacturer.html#encode/1"},{"type":"module","title":"Exmbus.Parser.TableLoader","doc":"Load a CSV file into a table.\nUsed to load CSVs at compile time for meta programming.","ref":"Exmbus.Parser.TableLoader.html"},{"type":"function","title":"Exmbus.Parser.TableLoader.from_enumerable!/1","doc":"","ref":"Exmbus.Parser.TableLoader.html#from_enumerable!/1"},{"type":"function","title":"Exmbus.Parser.TableLoader.from_file!/1","doc":"","ref":"Exmbus.Parser.TableLoader.html#from_file!/1"},{"type":"module","title":"Exmbus.Parser.TableLoader.TableCSV","doc":"","ref":"Exmbus.Parser.TableLoader.TableCSV.html"},{"type":"function","title":"Exmbus.Parser.TableLoader.TableCSV.dump_to_iodata/1","doc":"","ref":"Exmbus.Parser.TableLoader.TableCSV.html#dump_to_iodata/1"},{"type":"function","title":"Exmbus.Parser.TableLoader.TableCSV.dump_to_stream/1","doc":"","ref":"Exmbus.Parser.TableLoader.TableCSV.html#dump_to_stream/1"},{"type":"function","title":"Exmbus.Parser.TableLoader.TableCSV.parse_enumerable/2","doc":"","ref":"Exmbus.Parser.TableLoader.TableCSV.html#parse_enumerable/2"},{"type":"function","title":"Exmbus.Parser.TableLoader.TableCSV.parse_stream/2","doc":"","ref":"Exmbus.Parser.TableLoader.TableCSV.html#parse_stream/2"},{"type":"function","title":"Exmbus.Parser.TableLoader.TableCSV.parse_string/2","doc":"","ref":"Exmbus.Parser.TableLoader.TableCSV.html#parse_string/2"},{"type":"function","title":"Exmbus.Parser.TableLoader.TableCSV.to_line_stream/1","doc":"","ref":"Exmbus.Parser.TableLoader.TableCSV.html#to_line_stream/1"},{"type":"module","title":"Exmbus.Parser.Tpl","doc":"Module responsible for handling the transport layer.\nPrimarily described in EN 13757-7:2018.\n\nSee also the Exmbus.Parser.CI module.","ref":"Exmbus.Parser.Tpl.html"},{"type":"function","title":"Exmbus.Parser.Tpl.decrypt_bin/1","doc":"","ref":"Exmbus.Parser.Tpl.html#decrypt_bin/1"},{"type":"function","title":"Exmbus.Parser.Tpl.parse/1","doc":"Parses a transport layer and adds it to the parse context.\nThis function will return an error if the first byte\nis not a CI field describing a transport layer.","ref":"Exmbus.Parser.Tpl.html#parse/1"},{"type":"function","title":"Exmbus.Parser.Tpl.parse_tpl_header_long/1","doc":"Decode a TPL long header.\n\n  iex> parse_tpl_header_long(<<0x78,0x56,0x34,0x12,0x93,0x15,0x33,0x03,0x2A,0x00,0x00,0x00,0xFF,0xFF>>)\n  {:ok, %Exmbus.Parser.Tpl.Header.Long{\n    identification_no: \"12345678\",\n    manufacturer: \"ELS\",\n    version: 51,\n    device: %Exmbus.Parser.Tpl.Device{id: 0x03},\n    access_no: 42,\n    status: %Exmbus.Parser.Tpl.Status{},\n    configuration_field: %Exmbus.Parser.Tpl.ConfigurationField{},\n  }, <<0xFF, 0xFF>>}","ref":"Exmbus.Parser.Tpl.html#parse_tpl_header_long/1"},{"type":"type","title":"Exmbus.Parser.Tpl.t/0","doc":"","ref":"Exmbus.Parser.Tpl.html#t:t/0"},{"type":"module","title":"Exmbus.Parser.Tpl.ConfigurationField","doc":"This module represents the configuration field in the TPL layer.\n\nit contains metadata about the wmbus message.","ref":"Exmbus.Parser.Tpl.ConfigurationField.html"},{"type":"function","title":"Exmbus.Parser.Tpl.ConfigurationField.decode/1","doc":"","ref":"Exmbus.Parser.Tpl.ConfigurationField.html#decode/1"},{"type":"type","title":"Exmbus.Parser.Tpl.ConfigurationField.t/0","doc":"","ref":"Exmbus.Parser.Tpl.ConfigurationField.html#t:t/0"},{"type":"module","title":"Exmbus.Parser.Tpl.Device","doc":"A device type for the TPL header (also used in Wmbus DLL)","ref":"Exmbus.Parser.Tpl.Device.html"},{"type":"module","title":"Examples - Exmbus.Parser.Tpl.Device","doc":"iex> decode(<<0x03>>)\n    {:ok, %Exmbus.Parser.Tpl.Device{id: 3}}\n\n    iex> encode(%Exmbus.Parser.Tpl.Device{id: 3})\n    {:ok, <<3>>}\n\n    iex> format(%Exmbus.Parser.Tpl.Device{id: 3})\n    \"gas\"\n\n    iex> format(0x03)\n    \"gas\"","ref":"Exmbus.Parser.Tpl.Device.html#module-examples"},{"type":"function","title":"Exmbus.Parser.Tpl.Device.decode/1","doc":"decode a device byte into a Device struct","ref":"Exmbus.Parser.Tpl.Device.html#decode/1"},{"type":"function","title":"Exmbus.Parser.Tpl.Device.encode/1","doc":"encode a Device struct into a byte","ref":"Exmbus.Parser.Tpl.Device.html#encode/1"},{"type":"function","title":"Exmbus.Parser.Tpl.Device.format/1","doc":"return a string describing the Device","ref":"Exmbus.Parser.Tpl.Device.html#format/1"},{"type":"type","title":"Exmbus.Parser.Tpl.Device.t/0","doc":"","ref":"Exmbus.Parser.Tpl.Device.html#t:t/0"},{"type":"module","title":"Exmbus.Parser.Tpl.Encryption","doc":"This module handles the encryption of the TPL layer.","ref":"Exmbus.Parser.Tpl.Encryption.html"},{"type":"function","title":"Exmbus.Parser.Tpl.Encryption.decrypt_bin/1","doc":"decrypts the context data according to the TPL layer.\n\nThis function will decrypt the encrypted bytes according to the TPL encryption mode.","ref":"Exmbus.Parser.Tpl.Encryption.html#decrypt_bin/1"},{"type":"function","title":"Exmbus.Parser.Tpl.Encryption.encrypted?/1","doc":"Is tpl encrypted?","ref":"Exmbus.Parser.Tpl.Encryption.html#encrypted?/1"},{"type":"function","title":"Exmbus.Parser.Tpl.Encryption.encrypted_byte_count/1","doc":"Get the number of expected encrypted bytes in the APL binary","ref":"Exmbus.Parser.Tpl.Encryption.html#encrypted_byte_count/1"},{"type":"function","title":"Exmbus.Parser.Tpl.Encryption.encryption_mode/1","doc":"Return configured encryption mode as {:mode, m}","ref":"Exmbus.Parser.Tpl.Encryption.html#encryption_mode/1"},{"type":"module","title":"Exmbus.Parser.Tpl.Header.Long","doc":"This module represents the Long header in the TPL layer.","ref":"Exmbus.Parser.Tpl.Header.Long.html"},{"type":"type","title":"Exmbus.Parser.Tpl.Header.Long.t/0","doc":"","ref":"Exmbus.Parser.Tpl.Header.Long.html#t:t/0"},{"type":"module","title":"Exmbus.Parser.Tpl.Header.None","doc":"This module represents the None header in the TPL layer.","ref":"Exmbus.Parser.Tpl.Header.None.html"},{"type":"type","title":"Exmbus.Parser.Tpl.Header.None.t/0","doc":"","ref":"Exmbus.Parser.Tpl.Header.None.html#t:t/0"},{"type":"module","title":"Exmbus.Parser.Tpl.Header.Short","doc":"This module represents the short header of the TPL layer.","ref":"Exmbus.Parser.Tpl.Header.Short.html"},{"type":"type","title":"Exmbus.Parser.Tpl.Header.Short.t/0","doc":"","ref":"Exmbus.Parser.Tpl.Header.Short.html#t:t/0"},{"type":"module","title":"Exmbus.Parser.Tpl.Status","doc":"EN 13757-7:2018 (E) - 7.5.6 Status byte in meter messages\n\nMore details about the error state of the meter can be provided in the M-Bus\napplication protocol of the meter response (refer to EN 13757-3:2018, Annex E).","ref":"Exmbus.Parser.Tpl.Status.html"},{"type":"type","title":"Exmbus.Parser.Tpl.Status.application_status/0","doc":"","ref":"Exmbus.Parser.Tpl.Status.html#t:application_status/0"},{"type":"function","title":"Exmbus.Parser.Tpl.Status.decode/1","doc":"","ref":"Exmbus.Parser.Tpl.Status.html#decode/1"},{"type":"function","title":"Exmbus.Parser.Tpl.Status.encode/1","doc":"","ref":"Exmbus.Parser.Tpl.Status.html#encode/1"},{"type":"type","title":"Exmbus.Parser.Tpl.Status.t/0","doc":"","ref":"Exmbus.Parser.Tpl.Status.html#t:t/0"},{"type":"module","title":"Exmbus.Util","doc":"Utilities for manipulating data using the Exmbus library.","ref":"Exmbus.Util.html"},{"type":"function","title":"Exmbus.Util.extract_apl_bytes/2","doc":"Extract the APL bytes (after decryption) from the frame.","ref":"Exmbus.Util.html#extract_apl_bytes/2"},{"type":"function","title":"Exmbus.Util.rekey_ell/4","doc":"Re-key the ELL payload, returning the original headers with the rekeyed payload.","ref":"Exmbus.Util.html#rekey_ell/4"},{"type":"exception","title":"Exmbus.Parser.ParseError","doc":"","ref":"Exmbus.Parser.ParseError.html"},{"type":"extras","title":"Exmbus","doc":"# Exmbus\n\n[![Build Status](https://github.com/tudborg/exmbus/actions/workflows/elixir.yml/badge.svg?branch=main)](https://github.com/tudborg/exmbus/actions/workflows/elixir.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/exmbus.svg)](https://hex.pm/packages/exmbus)\n[![Documentation](https://img.shields.io/badge/documentation-gray)](https://hexdocs.pm/exmbus/)\n\n\nElixir M-Bus & Wireless M-Bus (wM-bus) parser library.\n\n> [!IMPORTANT]  \n> Although this library is already used in production I do not consider it robust enough to be crash-resistant against uncontrolled input.\n> It is a long-term goal of this library to never raise on parse failure.\n> However, we are not there yet. You'll probably want to wrap your calls to `Exmbus.parse` in a `try`.","ref":"readme.html"},{"type":"extras","title":"Installation - Exmbus","doc":"The package can be installed by adding `exmbus` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:exmbus, \"~> 0.2.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Features - Exmbus","doc":"- M-bus\n- wM-bus\n- TPL Encryption modes: 0, 5\n- (partly) supports ELL (supports encryption modes: 0 (none), 1 (aes_128_ctr)\n- Compact Frames and Format Frames\n- Compact Profiles\n- VIF extension tables 0xFD and 0xFB (with a few exceptions)","ref":"readme.html#features"},{"type":"extras","title":"Feature Requests - Exmbus","doc":"If you'd like a specific device supported, open an issue and attach or link to the datasheet for the device.  \nIf you can provide data from a real test device even better.\n\nNo effort will be made towards supporting a device without an example of a payload from the device (either from the datasheet or real world capture)\n\n> [!IMPORTANT]  \n> Under no circumstances should you publish data to the issue tracker or repository from a device that is actually deployed, as those might contain PII or other sensitive information.\n> The same is true encryption keys where the key might potentially be used in more than once device.","ref":"readme.html#feature-requests"},{"type":"extras","title":"Planned - Exmbus","doc":"- [ ] Better API for encryption key storage.\n- [ ] Transition the parser fully to handler + context based, and avoid raising on error but instead attach an error to the context. The APL layer in particular needs a lot of work here.\n- [ ] DLL CRC support.\n- [ ] Split parsing and decoding into two steps. Currently the code parses the binary and decodes it in the same walk, but this causes errors when we can't decode an unsupported feature.","ref":"readme.html#planned"},{"type":"extras","title":"Not Planned - Exmbus","doc":"- [ ] Authentication and Fragmentation layer CI=90","ref":"readme.html#not-planned"},{"type":"extras","title":"Performance - Exmbus","doc":"It's fine.\n\nYou can run the benchmarks under `benchmarks/` to get an idea of the performance on the relevant hardware.\n\nYou should test on frames that matches your deployment scenario, but if you just want a rough estimate,\nthere is a benchmark using an example frame from OMS Vol2 Annex N:\n\n```\nmix run benchmarks/oms_vol2_annex_n.exs\n```\n\nHere are the results we've gathered so far for the \"With input N.2.1. wM-Bus Meter with Security profile A\" bench\n\n\n| Hardware                  |        ips |       average | deviation |        median |        99th % |\n|---------------------------|------------|---------------|-----------|---------------|---------------|\n| Apple 12 core M3 Pro 36GB |   289.61 K |       3.45 μs |   ±63.73% |       3.13 μs |       7.21 μs |","ref":"readme.html#performance"},{"type":"extras","title":"Examples - Exmbus","doc":"","ref":"readme.html#examples"},{"type":"extras","title":"Parse wM-Bus - Exmbus","doc":"This is an example from the OMS Vol2 Annex N - N.2.1. wM-Bus Meter with Security profile A\n\n`Exmbus.parse!` will return an `Exmbus.Parser.Context` struct as the result.\n\n```elixir\niex> \"2E4493157856341233037A2A0020255923C95AAA26D1B2E7493B013EC4A6F6D3529B520EDFF0EA6DEFC99D6D69EBF3\"\n...> |> Base.decode16!()\n...> |> Exmbus.parse!(key: Base.decode16!(\"0102030405060708090A0B0C0D0E0F11\"))\n%Exmbus.Parser.Context{\n  bin: \"\",\n  opts: %{\n    length: false,\n    key: <<1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 17>>,\n    crc: false\n  },\n  handlers: [],\n  handler: &Exmbus.Parser.Apl.FullFrame.maybe_expand_compact_profiles/1,\n  dll: %Exmbus.Parser.Dll.Wmbus{\n    control: :snd_nr,\n    manufacturer: \"ELS\",\n    identification_no: \"12345678\",\n    version: 51,\n    device: %Exmbus.Parser.Tpl.Device{id: 3}\n  },\n  ell: %Exmbus.Parser.Ell.None{},\n  tpl: %Exmbus.Parser.Tpl{\n    frame_type: :full_frame,\n    header: %Exmbus.Parser.Tpl.Header.Short{\n      access_no: 42,\n      status: %Exmbus.Parser.Tpl.Status{\n        manufacturer_status: 0,\n        temporary_error: false,\n        permanent_error: false,\n        low_power: false,\n        application_status: :no_error\n      },\n      configuration_field: %Exmbus.Parser.Tpl.ConfigurationField{\n        hop_count: 0,\n        repeater_access: 0,\n        content_of_message: 0,\n        mode: 5,\n        syncrony: true,\n        accessibility: false,\n        bidirectional: false,\n        blocks: 2\n      }\n    }\n  },\n  apl: %Exmbus.Parser.Apl.FullFrame{\n    records: [\n      %Exmbus.Parser.Apl.DataRecord{\n        header: %Exmbus.Parser.Apl.DataRecord.Header{\n          dib_bytes: \"\\f\",\n          vib_bytes: <<20>>,\n          dib: %Exmbus.Parser.Apl.DataRecord.DataInformationBlock{\n            device: 0,\n            tariff: 0,\n            storage: 0,\n            function_field: :instantaneous,\n            data_type: :bcd,\n            size: 32\n          },\n          vib: %Exmbus.Parser.Apl.DataRecord.ValueInformationBlock{\n            description: :volume,\n            multiplier: 0.01,\n            unit: \"m^3\",\n            extensions: [],\n            coding: nil,\n            table: :main\n          },\n          coding: :type_a\n        },\n        data: 2850427\n      },\n      %Exmbus.Parser.Apl.DataRecord{\n        header: %Exmbus.Parser.Apl.DataRecord.Header{\n          dib_bytes: <<4>>,\n          vib_bytes: \"m\",\n          dib: %Exmbus.Parser.Apl.DataRecord.DataInformationBlock{\n            device: 0,\n            tariff: 0,\n            storage: 0,\n            function_field: :instantaneous,\n            data_type: :int_or_bin,\n            size: 32\n          },\n          vib: %Exmbus.Parser.Apl.DataRecord.ValueInformationBlock{\n            description: :naive_datetime,\n            multiplier: nil,\n            unit: nil,\n            extensions: [],\n            coding: :type_f,\n            table: :main\n          },\n          coding: :type_f\n        },\n        data: ~N[2008-05-31 23:50:00]\n      },\n      %Exmbus.Parser.Apl.DataRecord{\n        header: %Exmbus.Parser.Apl.DataRecord.Header{\n          dib_bytes: <<2>>,\n          vib_bytes: <<253, 23>>,\n          dib: %Exmbus.Parser.Apl.DataRecord.DataInformationBlock{\n            device: 0,\n            tariff: 0,\n            storage: 0,\n            function_field: :instantaneous,\n            data_type: :int_or_bin,\n            size: 16\n          },\n          vib: %Exmbus.Parser.Apl.DataRecord.ValueInformationBlock{\n            description: :error_flags,\n            multiplier: nil,\n            unit: nil,\n            extensions: [],\n            coding: :type_d,\n            table: :fd\n          },\n          coding: :type_d\n        },\n        data: [false, false, false, false, false, false, false, false, false,\n         false, false, false, false, false, false, false]\n      }\n    ],\n    manufacturer_bytes: \"\"\n  },\n  dib: nil,\n  vib: nil,\n  errors: [],\n  warnings: []\n}\n```","ref":"readme.html#parse-wm-bus"},{"type":"extras","title":"Testing - Exmbus","doc":"`mix test`","ref":"readme.html#testing"},{"type":"extras","title":"Profiling - Exmbus","doc":"Some profiling scripts are available under `profiling/`.\n\nYou can run then with e.g. eprof:\n\n```sh\n mix profile.eprof profiling/oms_vol2_annex_n.exs\n```","ref":"readme.html#profiling"},{"type":"extras","title":"Changelog for v0.x","doc":"# Changelog for v0.x\n\n## [Unreleased]\n\n## [v0.3.0]","ref":"changelog.html"},{"type":"extras","title":"Changed - Changelog for v0.x","doc":"- BREAKING: Making identification numbers **strings instead of integers**.\n  This allows us to represent wildcard `F`s at any position.\n- Parsing of the lower layers (DLL and TPL) have been made less brittle and will\n  in more cases register errors in the context instead of raising an exception.\n- BREAKING: Device value in DLL and TPL have been changed from an atom to a struct\n  of type `Exmbus.Parser.Tpl.Device`","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog for v0.x","doc":"- Support for tariff related VIFE in 0xFD table `E011 00NN`.\n- Support for VIFE in 0xFD: `E110 0110` State of parameter activation.\n- Support for VIF `E001 1101` (Standard conform data content)\n- Test for LAN-WMBUS-G2-LDS/LDP.\n- Support for expansion of Compact Profile with Register Numbers (Orthogonal VIFE 0x1E)","ref":"changelog.html#added"},{"type":"extras","title":"v0.2.0 - Changelog for v0.x","doc":"Open-sourced","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright [yyyy] [name of copyright owner]\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}